    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ------------------------------
    028     * KeypointPNGEncoderAdapter.java
    029     * ------------------------------
    030     * (C) Copyright 2004-2008, by Richard Atkinson and Contributors.
    031     *
    032     * Original Author:  Richard Atkinson;
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 01-Aug-2004 : Initial version (RA);
    038     * 02-Feb-2007 : Removed author tags all over JFreeChart sources (DG);
    039     *
    040     */
    041
    042    package org.jfree.chart.encoders;
    043
    044    import java.awt.image.BufferedImage;
    045    import java.io.IOException;
    046    import java.io.OutputStream;
    047
    048    import com.keypoint.PngEncoder;
    049
    050    /**
    051     * Adapter class for the Keypoint PNG Encoder.  The ImageEncoderFactory will
    052     * only return a reference to this class by default if the library has been
    053     * compiled under a JDK < 1.4 or is being run using a JDK < 1.4.
    054     */
    055    public class KeypointPNGEncoderAdapter implements ImageEncoder {
    056
    057        /** The quality setting. */
    058        private int quality = 9;
    059
    060        /** Encode alpha? */
    061        private boolean encodingAlpha = false;
    062
    063        /**
    064         * Get the quality of the image encoding.  The underlying encoder uses int
    065         * values:  0 for no compression, and values 1 through 9 for various levels
    066         * of compression (1 is best speed, 9 is best compression).
    067         *
    068         * @return A float representing the quality.
    069         */
    070        public float getQuality() {
    071            return this.quality;
    072        }
    073
    074        /**
    075         * Set the quality of the image encoding (supported).  The underlying
    076         * encoder uses int values:  0 for no compression, and values 1 through 9
    077         * for various levels of compression (1 is best speed, 9 is best
    078         * compression).
    079         *
    080         * @param quality  A float representing the quality.
    081         */
    082        public void setQuality(float quality) {
    083            this.quality = (int) quality;
    084        }
    085
    086        /**
    087         * Get whether the encoder should encode alpha transparency.
    088         *
    089         * @return Whether the encoder is encoding alpha transparency.
    090         */
    091        public boolean isEncodingAlpha() {
    092            return this.encodingAlpha;
    093        }
    094
    095        /**
    096         * Set whether the encoder should encode alpha transparency (supported).
    097         *
    098         * @param encodingAlpha  Whether the encoder should encode alpha
    099         *                       transparency.
    100         */
    101        public void setEncodingAlpha(boolean encodingAlpha) {
    102            this.encodingAlpha = encodingAlpha;
    103        }
    104
    105        /**
    106         * Encodes an image in PNG format.
    107         *
    108         * @param bufferedImage  The image to be encoded.
    109         * @return The byte[] that is the encoded image.
    110         * @throws IOException
    111         */
    112        public byte[] encode(BufferedImage bufferedImage) throws IOException {
    113            if (bufferedImage == null) {
    114                throw new IllegalArgumentException("Null 'image' argument.");
    115            }
    116            PngEncoder encoder = new PngEncoder(bufferedImage, this.encodingAlpha,
    117                    0, this.quality);
    118            return encoder.pngEncode();
    119        }
    120
    121        /**
    122         * Encodes an image in PNG format and writes it to an
    123         * <code>OutputStream</code>.
    124         *
    125         * @param bufferedImage  The image to be encoded.
    126         * @param outputStream  The OutputStream to write the encoded image to.
    127         * @throws IOException
    128         */
    129        public void encode(BufferedImage bufferedImage, OutputStream outputStream)
    130            throws IOException {
    131            if (bufferedImage == null) {
    132                throw new IllegalArgumentException("Null 'image' argument.");
    133            }
    134            if (outputStream == null) {
    135                throw new IllegalArgumentException("Null 'outputStream' argument.");
    136            }
    137            PngEncoder encoder = new PngEncoder(bufferedImage, this.encodingAlpha,
    138                    0, this.quality);
    139            outputStream.write(encoder.pngEncode());
    140        }
    141
    142    }